#define MAIN_LABEL "PR electronics PRetop 5335 - Temperature Meter"

#define CYCLE_TIME_PV_CHART 				3000 // 3s update time

#define degC  32
#define degF  33
#define degR  34
#define degK  35
#define Volt  58
#define mVolt 36
#define _Ohm  37
#define kOhm  163

#define CELSIUS_TO_CURRENT_UNIT(a)				\
switch(ivar_value(pv_digital_units))	\
{												\
	case Volt : a = a / 1000; break;			\
	case kOhm : a = a / 1000; break;			\
	case degC : a = a; break;					\
	case degK : a = a + 273.15; break;			\
	case degF : a = a * 1.8 + 32; break;		\
	case degR : a = a * 1.8 + 491.67; break;	\
}

#define CURRENT_UNIT_TO_CELSIUS(a)				\
switch(ivar_value(pv_digital_units))	\
{												\
	case Volt : a = a * 1000; break;			\
	case kOhm : a = a * 1000; break;			\
	case degC : a = a; break;					\
	case degK : a = a - 273.15; break;			\
	case degF : a = (a - 32) / 1.8; break;		\
	case degR : a = (a - 491.15) / 1.8; break;\
}

#define ALL_UNITS  \
		UNITS_CODE (1), \
		UNITS_CODE (2), \
		UNITS_CODE (3), \
		UNITS_CODE (4), \
		UNITS_CODE (5), \
		UNITS_CODE (6), \
		UNITS_CODE (7), \
		UNITS_CODE (8), \
		UNITS_CODE (9), \
		UNITS_CODE (10), \
		UNITS_CODE (11), \
		UNITS_CODE (12), \
		UNITS_CODE (13), \
		UNITS_CODE (14), \
		UNITS_CODE (15), \
		UNITS_CODE (16), \
		UNITS_CODE (17), \
		UNITS_CODE (18), \
		UNITS_CODE (19), \
		UNITS_CODE (20), \
		UNITS_CODE (21), \
		UNITS_CODE (22), \
		UNITS_CODE (23), \
		UNITS_CODE (24), \
		UNITS_CODE (25), \
		UNITS_CODE (26), \
		UNITS_CODE (27), \
		UNITS_CODE (28), \
		UNITS_CODE (29), \
		UNITS_CODE (30), \
		UNITS_CODE (31), \
		UNITS_CODE (32), \
		UNITS_CODE (33), \
		UNITS_CODE (34), \
		UNITS_CODE (35), \
		UNITS_CODE (36), \
		UNITS_CODE (37), \
		UNITS_CODE (38), \
		UNITS_CODE (39), \
		UNITS_CODE (40), \
		UNITS_CODE (41), \
		UNITS_CODE (42), \
		UNITS_CODE (43), \
		UNITS_CODE (44), \
		UNITS_CODE (45), \
		UNITS_CODE (46), \
		UNITS_CODE (47), \
		UNITS_CODE (48), \
		UNITS_CODE (49), \
		UNITS_CODE (50), \
		UNITS_CODE (51), \
		UNITS_CODE (52), \
		UNITS_CODE (53), \
		UNITS_CODE (54), \
		UNITS_CODE (55), \
		UNITS_CODE (56), \
		UNITS_CODE (57), \
		UNITS_CODE (58), \
		UNITS_CODE (59), \
		UNITS_CODE (60), \
		UNITS_CODE (61), \
		UNITS_CODE (62), \
		UNITS_CODE (63), \
		UNITS_CODE (64), \
		UNITS_CODE (65), \
		UNITS_CODE (66), \
		UNITS_CODE (67), \
		UNITS_CODE (68), \
		UNITS_CODE (69), \
		UNITS_CODE (70), \
		UNITS_CODE (71), \
		UNITS_CODE (72), \
		UNITS_CODE (73), \
		UNITS_CODE (74), \
		UNITS_CODE (75), \
		UNITS_CODE (76), \
		UNITS_CODE (77), \
		UNITS_CODE (78), \
		UNITS_CODE (79), \
		UNITS_CODE (80), \
		UNITS_CODE (81), \
		UNITS_CODE (82), \
		UNITS_CODE (83), \
		UNITS_CODE (84), \
		UNITS_CODE (85), \
		UNITS_CODE (86), \
		UNITS_CODE (87), \
		UNITS_CODE (88), \
		UNITS_CODE (90), \
		UNITS_CODE (91), \
		UNITS_CODE (92), \
		UNITS_CODE (93), \
		UNITS_CODE (94), \
		UNITS_CODE (95), \
		UNITS_CODE (96), \
		UNITS_CODE (97), \
		UNITS_CODE (98), \
		UNITS_CODE (99), \
		UNITS_CODE (100), \
		UNITS_CODE (101), \
		UNITS_CODE (102), \
		UNITS_CODE (103), \
		UNITS_CODE (104), \
		UNITS_CODE (105), \
		UNITS_CODE (106), \
		UNITS_CODE (107), \
		UNITS_CODE (108), \
		UNITS_CODE (109), \
		UNITS_CODE (110), \
		UNITS_CODE (111), \
		UNITS_CODE (112), \
		UNITS_CODE (113), \
		UNITS_CODE (114), \
		UNITS_CODE (115), \
		UNITS_CODE (116), \
		UNITS_CODE (117), \
		UNITS_CODE (118), \
		UNITS_CODE (119), \
		UNITS_CODE (120), \
		UNITS_CODE (121), \
		UNITS_CODE (122), \
		UNITS_CODE (123), \
		UNITS_CODE (124), \
		UNITS_CODE (125), \
		UNITS_CODE (126), \
		UNITS_CODE (127), \
		UNITS_CODE (128), \
		UNITS_CODE (129), \
		UNITS_CODE (130), \
		UNITS_CODE (131), \
		UNITS_CODE (132), \
		UNITS_CODE (133), \
		UNITS_CODE (134), \
		UNITS_CODE (135), \
		UNITS_CODE (136), \
		UNITS_CODE (137), \
		UNITS_CODE (138), \
		UNITS_CODE (139), \
		UNITS_CODE (140), \
		UNITS_CODE (141), \
		UNITS_CODE (142), \
		UNITS_CODE (143), \
		UNITS_CODE (150), \
		UNITS_CODE (151), \
		UNITS_CODE (152), \
		UNITS_CODE (153), \
		UNITS_CODE (160), \
		UNITS_CODE (162), \
		UNITS_CODE (163), \
		UNITS_CODE (164), \
		UNITS_CODE (165), \
		UNITS_CODE (166), \
		UNITS_CODE (167), \
		UNITS_CODE (168), \
		UNITS_CODE (235), \
		UNITS_CODE (236), \
		UNITS_CODE (237), \
		UNITS_CODE (239), \
		UNITS_CODE (250), \
		UNITS_CODE (251), \
		UNITS_CODE (252), \
		UNITS_CODE (253)

#define DUAL_SENS \
	SELECT(measurement_type) \
	{                     \
		 CASE 0: TRUE; 	\
		 CASE 1: TRUE;   \
		 CASE 2: TRUE;   \
		 CASE 3: TRUE;   \
		 CASE 4: TRUE;   \
		 CASE 9: TRUE;   \
		 CASE 10: TRUE;  \
		 CASE 11: TRUE;  \
		 CASE 12: TRUE;  \
		 CASE 16: TRUE;  \
		 DEFAULT: FALSE; \
	}

#define CONST_CJC \
	IF (sensor_type < 129 || sensor_type > 141) \
	{ FALSE; } \
	ELSE \
	{ SELECT(measurement_type) { \
			 CASE 3: TRUE;   \
			 CASE 8: TRUE;   \
			 CASE 12: TRUE;  \
			 DEFAULT: FALSE; \
		}\
	}

#define PT_NI \
	SELECT(sensor_type) \
	{                     \
		 CASE 1: TRUE;   \
		 CASE 2: TRUE;  \
		 DEFAULT: FALSE; \
	}


#define DIFF_SENS \
	SELECT(measurement_type) \
	{                     \
		 CASE 0: TRUE; 	\
		 CASE 1: TRUE;   \
		 CASE 2: TRUE;   \
		 CASE 3: TRUE;   \
		 CASE 4: TRUE;   \
		 DEFAULT: FALSE; \
	}

#define CAB_RES \
	SELECT(measurement_type) \
	{                     \
		 CASE 0: FALSE;   \
		 CASE 3: FALSE;   \
		 CASE 5: FALSE;   \
		 CASE 8: FALSE;   \
		 CASE 9: FALSE;  \
		 CASE 12: FALSE;  \
		 DEFAULT: TRUE; \
	}

#define EXT_CJC \
	IF (sensor_type==128) \
	{ "Electronics Temperature"; } \
	ELSE		\
	{	SELECT(measurement_type) {  \
			CASE 0: "Internal CJC";   \
			CASE 1: "External CJC";   \
			CASE 2: "External CJC";   \
			CASE 5: "Internal CJC";   \
			CASE 6: "External CJC";   \
			CASE 7: "External CJC";   \
			CASE 9: "Internal CJC" ;   \
			CASE 10:"External CJC";  \
			CASE 11: "External CJC";  \
			DEFAULT: "Electronics Temperature"; \
		}	\
	}

/***********************************************************************/
/*    Includes       												   */
/***********************************************************************/
#include "bi_codes.h"
#include "macros.ddl"

MANUFACTURER PR_ELECTRONICS, DEVICE_TYPE _PR5335, DEVICE_REVISION 1, DD_REVISION 2

#include "SI_FileM.inc"
#include "SI_DevM.inc"
#include "SI_HlpM.inc"
#include "SI_OptM.inc"

/* COMMON TABLES */
IMPORT STANDARD _TABLES, DEVICE_REVISION 9, DD_REVISION 2
{
	EVERYTHING;
}

/* UNIVERSAL COMMANDS */
IMPORT STANDARD _UNIVERSAL, DEVICE_REVISION 5, DD_REVISION 1
{
	EVERYTHING;

	REDEFINITIONS
	{
		VARIABLE manufacturer_id
		{
			REDEFINE TYPE ENUMERATED
			{
				{ 109, "PR electronics A/S" }
			}
		}

		VARIABLE device_type
		{
			REDEFINE TYPE ENUMERATED
			{
				{239, "PRetop 5335"}
			}
		}

		/*
		 * redefinition of variable device_status (univ.ddl)
		 * TRANSMITTER STATUS (second byte)
		 * Non pv out of limits requires more information
		 */

		VARIABLE  device_status
		{
			REDEFINE TYPE BIT_ENUMERATED
 		  {
				{ 0x01, [PV_out_of_limits],             DV1 (AUTO & BAD) },
				{ 0x02, [Non_PV_out_of_limits],         MORE },
				{ 0x04, [PV_analog_output_saturated],   AO1 (AUTO & BAD) },
				{ 0x08, [PV_analog_output_fixed],       AO1 (MANUAL & GOOD) },
				{ 0x10, [more_status_available],        MORE },
				{ 0x20, [cold_start],                   MISC },
				{ 0x40, [configuration_changed],        MISC & IGNORE_IN_HANDHELD },
				{ 0x80, [device_malfunction],           MORE }
			}
		}

		VARIABLE write_protect
		{
			REDEFINE TYPE ENUMERATED
			{
	      { 0, "Not Write Protected" },
	      { 1, "Write Protected" }
			}
		}

		VARIABLE private_label_distributor
		{
			REDEFINE TYPE ENUMERATED
			{
	      { 109, "PR Electronics A/S" }
			}
		}
/*
		VARIABLE polling_address
		{
			REDEFINE PRE_EDIT_ACTIONS before_poll
		}
*/
	}
}

/* COMMON PRACTICE  COMMANDS */
IMPORT STANDARD _COMMON_PRACTICE, DEVICE_REVISION 7, DD_REVISION 1
{
	VARIABLE xmtr_specific_status_0;
	VARIABLE xmtr_specific_status_1;
	VARIABLE xmtr_specific_status_2;
	VARIABLE response_preambles;
	COMMAND  write_pv_damping_value;           /* 34 OK */
	COMMAND  write_pv_range_values;            /* 35 OK */
	COMMAND  reset_configuration_change_flag;  /* 38 OK */
	COMMAND  enter_exit_fixed_pv_current_mode; /* 40 OK */
	COMMAND  perform_master_reset;             /* 42 OK */
	COMMAND  write_pv_units;                   /* 44 OK */
	COMMAND  trim_pv_current_dac_zero;         /* 45 OK */
	COMMAND  trim_pv_current_dac_gain;         /* 46 OK */
	COMMAND  read_additional_transmitter_status; /* 48 OK */
	COMMAND	 write_number_of_response_preambles; /* 59 OK */

	/* standard method */
	METHOD loop_test;
	METHOD dac_trim;
	METHOD scaled_dac_trim;
	METHOD leave_fixed_current_mode;
	METHOD return_to_normal;

	REDEFINITIONS
	{
		VARIABLE xmtr_specific_status_0 /* Sensor error byte */
		{
			REDEFINE LABEL "Sensor errors";
			REDEFINE HELP	"Error status byte, indicates errors related to sensors or sensorwires";
			REDEFINE TYPE BIT_ENUMERATED
			{
				{ 1, "sensor1",             HARDWARE },
				{ 2, "sensor2",             HARDWARE },
				{ 4, "CJC/electr sens",   	HARDWARE }
			}
			REDEFINE STYLE "MULTILINE 16 3";
		}


		VARIABLE xmtr_specific_status_1 /* ADC error byte */
		{
			REDEFINE LABEL "ADC errors";
			REDEFINE HELP	"Error status byte, indicates errors related to the analog to digital converter or the input stage of the device.";
			REDEFINE TYPE BIT_ENUMERATED
			{
				{ 1, "# ADC bits",      HARDWARE },
				{ 4, "Xor ADC data",    HARDWARE },
				{ 8, "Missing meas",  	HARDWARE },
				{ 16, "ADC init",       	HARDWARE }
			}
			REDEFINE STYLE "MULTILINE 16 4";
		}


		VARIABLE xmtr_specific_status_2 /* Main error byte */
		{
			REDEFINE LABEL "Misc. errors";
			REDEFINE HELP	"Error status byte, indicates errors related to the device.";
			REDEFINE TYPE BIT_ENUMERATED
			{
				{ 1, "EEP ack error",       HARDWARE },
				{ 2, "EEP xor",			HARDWARE },
				{ 4, "Downscl RAM xor",     HARDWARE },
				{ 8, "Downscl ADC",  		HARDWARE },
				{ 16, "EEP-read err",  			HARDWARE },
				{ 32, "Watchdog tmout",			HARDWARE }
			}
			REDEFINE STYLE "MULTILINE 16 6";
		}


		COMMAND read_additional_transmitter_status
		{
			REDEFINE TRANSACTION
			{
				REQUEST
				{}
				REPLY
				{
					response_code,
					device_status,
					xmtr_specific_status_0,
					xmtr_specific_status_1,
					xmtr_specific_status_2
				}
			}
		}
	}
}

IMPORT STANDARD _MENU, DEVICE_REVISION 1, DD_REVISION 1
{
	MENU hot_key;
	EDIT_DISPLAY rerange;
	WRITE_AS_ONE range_wao;
}

/* Transmitter Variables Configuration */

VARIABLE pv_digital_units
/*
 * Subset of Table II, Unit Codes.
 */

{
	LABEL "Unit";
	HELP "Field Device Variable Unit - Engineering unit that the"
			 " Digital Value, Upper Range Value and Lower Range value"
			 " will be displayed with. Any unit defined in Table 2. Unit"
			 " Codes of the Common Tables document will be accepted, but"
			 " calculation of values between units by the device, are only done when units"
			 " are degC, degF ,degR or Kelvin";
	TYPE ENUMERATED
	{
    DEFAULT_VALUE degC;

		ALL_UNITS
	}
	POST_EDIT_ACTIONS
	{
    method_sensor_type,
    method_sensor_limits,
    method_measurement_type
  }
	HANDLING READ & WRITE;
}


VARIABLE atransfer_function
{
	LABEL [transfer_function];
	TYPE ENUMERATED
	{
		TRANSFER_FUNCTION_CODE (0)         /* Linear */
	}
}


VARIABLE pv_digital_value
{
	LABEL [pv];
	HELP "Field Device Variable Value - Digital value that dynamicly"
			 " represents the actual measured primary value of the device, in engineering units.";
	TYPE  FLOAT
	{
		DISPLAY_FORMAT ".2f";
		EDIT_FORMAT	".4f";
	}
	CLASS CORRECTION & DYNAMIC;
	HANDLING READ;
}

VARIABLE analog_value
{
	LABEL "PV AO"; /* [pv_analog_value]; */
	HELP "Analog Output value - Indicates the current output of the field"
			 " instrument. ";
	CONSTANT_UNIT [mA];
	TYPE FLOAT
	{
		DISPLAY_FORMAT ".2f";
		EDIT_FORMAT ".4f";
	}
	CLASS ANALOG_OUTPUT & DYNAMIC;
	HANDLING READ & WRITE;
}

VARIABLE percent_range
{
	LABEL [pv_percent_range];
	HELP "Percent of Range - Digital value that is proportional to"
	" the Digital Value with respect to the range defined by"
	" the Lower Range Value and the Upper Range Value. The Units"
	" of this variable is always in percent. ";
	CONSTANT_UNIT "%";
	TYPE FLOAT
	{
		DISPLAY_FORMAT ".2f";
	}
	CLASS DYNAMIC & INPUT;
	HANDLING READ;
}

VARIABLE alarm_select
{
	CLASS ANALOG_OUTPUT;
	LABEL [alarm_select];
	TYPE ENUMERATED
	{
		 { 0,   "High" },
		 { 1,   "Low" },
		 { 251, "None" },
		 { 253, "Special" }
	}
}

VARIABLE upper_range_value
{
	LABEL "Upper Range Value";
	HELP  [upper_range_value_help];
	TYPE FLOAT
	{
		DEFAULT_VALUE 150.0;
    DISPLAY_FORMAT ".2f";
		EDIT_FORMAT ".2f";
	}
	POST_EDIT_ACTIONS
	{
    method_sensor_limits
  }
	HANDLING READ & WRITE;
}

VARIABLE lower_range_value
{
	LABEL "Lower Range Value";
	HELP [lower_range_value_help];
		TYPE FLOAT
	{
    DEFAULT_VALUE 0.0;
		DISPLAY_FORMAT ".2f";
		EDIT_FORMAT ".2f";
	}
	POST_EDIT_ACTIONS
	{
    method_sensor_limits
  }
	HANDLING READ & WRITE;
}

VARIABLE damping_value
{
	HELP "Damping Value - Damping time constant applied to both the"
			 " Digital Value and Analog Value of the respective output. The"
			 " Unit of this variable is always in seconds. ";
	LABEL "Damping";
	CONSTANT_UNIT [sec];
	TYPE FLOAT
	{
    DEFAULT_VALUE 1.0;
		DISPLAY_FORMAT "2.2f";
		EDIT_FORMAT "5.24f";
	}
	POST_EDIT_ACTIONS
	{
    method_damping_value
  }
	HANDLING READ & WRITE;
}

VARIABLE atemperature_upper_sensor_limit
{
	LABEL [usl];
	HELP "Upper Sensor Limit - Value that defines the absolute"
			 " upper endpoint (largest magnitude) for the digital value. "
			 " Temperature - Temperature of the process measured with respect to"
			 " some reference pressure. ";
	TYPE FLOAT
	{
    DEFAULT_VALUE 850.0;
    DISPLAY_FORMAT ".2f";
	}
	CLASS CORRECTION;
	HANDLING READ;
}

VARIABLE atemperature_lower_sensor_limit
{
	LABEL [lsl];
	HELP "Lower Sensor Limit - Value that defines the absolute"
			 " lower endpoint (smallest magnitude) for the digital value."
			 " Temperature - Temperature of the process measured with respect to"
			 " some reference pressure. ";
	TYPE FLOAT
	{
    DEFAULT_VALUE -200.0;
		DISPLAY_FORMAT ".2f";
	}
	HANDLING READ;
	CLASS CORRECTION;
}

VARIABLE atemperature_minimum_span
{
	LABEL [minimum_span];
	HELP "Minimum Span value - Indicates the minimum allovable value"
			 " for the span. The span is the algebraic difference between"
			 " the Upper and Lower Range Value. ";
	TYPE FLOAT
	{
    DEFAULT_VALUE 10.0;
		DISPLAY_FORMAT ".2f";
	}
	CLASS DEVICE;
	HANDLING READ;
}

VARIABLE atemperature_sensor_serial_number
{
	LABEL [sensor_serial_number];
	HELP "Sensor Serial Number - Indicates the sensor's module serial"
			 " number. ";
	TYPE UNSIGNED_INTEGER (3)
	{
		DISPLAY_FORMAT "7d";
	}
	CLASS DEVICE;
	HANDLING READ;
}

VARIABLE sensor_limit_units
{
	LABEL "Sensor Limits Units";
	HELP "Sensor Limit Units and Minimum Span Units - Engineering"
			 " unit that the Upper Sensor Limit, Lower Sensor Limit and"
			 " Minimum Span will be displayed with. ";
	TYPE ENUMERATED
	{
		ALL_UNITS
	}
	CLASS CORRECTION;
	HANDLING READ;
}

VARIABLE sensor1_units
/*
 * Subset of Table II, Unit Codes.
 */
{
	LABEL	"Sensor 1 Units";

	HELP "Sensor 1 Units - For differential or average measurements only";
	TYPE ENUMERATED
	{
		ALL_UNITS
	}
	CLASS CORRECTION;
	HANDLING READ;
	VALIDITY DUAL_SENS
}

VARIABLE sensor1_digital_value
{
	LABEL "Snsr1";
	HELP "Sensor 1 digital value - For differential or average measurements only";
	TYPE  FLOAT
	{
		DISPLAY_FORMAT ".2f";
		EDIT_FORMAT	".4f";
	}
	CLASS CORRECTION & DYNAMIC;
	HANDLING READ;
	VALIDITY DUAL_SENS
}

VARIABLE sensor2_units
/*
 * Subset of Table II, Units Codes.
 */
{
	LABEL "Sensor 2 Units";
	HELP "Sensor 2 Units - For differential or average measurments only";
	TYPE ENUMERATED
	{
		ALL_UNITS
	}
	CLASS CORRECTION;
	HANDLING READ;
	VALIDITY DUAL_SENS
}

VARIABLE sensor2_digital_value
{
	LABEL "Snsr2";
	HELP "Sensor 2 digital value - For differential or average measurements only";

	TYPE  FLOAT
	{
		DISPLAY_FORMAT ".2f";
		EDIT_FORMAT	".4f";
	}
	CLASS CORRECTION & DYNAMIC;
	HANDLING READ;
	VALIDITY DUAL_SENS
}

VARIABLE cjc_electr_sensor_units
/*
 * From Table 11.1 of the Transmitter Specific Document, Rev 03
 * Subset of Table II, Unit Codes.
 */
{
	LABEL "CJC/electronics temp units";
	HELP "CJC/ electronics temperature digital units";
	TYPE ENUMERATED
	{
		UNITS_CODE (degC),  
		UNITS_CODE (degF),  
		UNITS_CODE (degR),  
		UNITS_CODE (degK)	  
	}
	CLASS CORRECTION;
	HANDLING READ;
}


VARIABLE cjc_electr_sensor_digital_value
{
	LABEL	EXT_CJC
	HELP "If CJC compensation is selected: CJC temperature."
			 "Else electronics temperature";
	TYPE  FLOAT
	{
		DISPLAY_FORMAT ".2f";
		EDIT_FORMAT	".4f";
	}
	CLASS CORRECTION & DYNAMIC;
	HANDLING READ;
}


VARIABLE sensor_type
/*
 * From Table 4 of the Transmitter Specific Document, Rev 01
 */
{
	LABEL [sensor_type];
	HELP "Sensor type - Indicates the type of the sensor element:"
			 " millivolt, thermocouple type, resistance thermometer type, ohms. ";
	TYPE ENUMERATED
	{
    DEFAULT_VALUE 1;

		/* If temperature */
    IF(pv_digital_units == degC || pv_digital_units == degF || 
       pv_digital_units == degR || pv_digital_units == degK)
    {
		  { 1,    "Pt100 IEC 751"        }, 
		  { 2,    "Ni100 DIN 43760"      }, 
		  { 5,    "RTD Special"          }, 
		  { 129,  "T/C Type B IEC 584"   }, 
		  { 130,  "T/C Type E IEC 584"   }, 
		  { 131,  "T/C Type J IEC 584"   }, 
		  { 132,  "T/C Type K IEC 584"   }, 
		  { 133,  "T/C Type L DIN 43710" }, 
		  { 134,  "T/C Type N IEC 584"   }, 
		  { 135,  "T/C Type R IEC 584"   }, 
		  { 136,  "T/C Type S IEC 584"   }, 
		  { 137,  "T/C Type T IEC 584"   }, 
		  { 138,  "T/C Type U DIN 43710" }, 
		  { 139,  "T/C Type W3 ASTM"     }, 
		  { 140,  "T/C Type W5 ASTM"     }, 
		  { 141,  "T/C Special"          }  
    }
    ELSE
    {
      /* V, mV */
      IF(pv_digital_units == Volt || pv_digital_units == mVolt)
      {
		    { 128,  [millivolts] }
      }
      ELSE
      {
        /* If Ohm, kOhm */
        IF(pv_digital_units == _Ohm || pv_digital_units == kOhm)
        {
          { 0,    [ohms] }
        }
        ELSE
        {
  		    { 128,  [millivolts] },
          { 0,    [ohms] }
        }
      }
    }
	}
  POST_EDIT_ACTIONS
  {
    method_sensor_limits,
    method_measurement_type
  }
	CLASS DEVICE;
	HANDLING READ & WRITE;
}

VARIABLE measurement_type
/*
 * From Table 5 of the Transmitter Specific Document, Rev 01
 */
{
	LABEL "Measurement Type";
	HELP "Measurement type - Indicates the type of measurement:"
			 " single/differential or average, internal/external or const CJC, external CJC sensor Pt100 or Ni100, 2/3 or 4 wire.";
	TYPE ENUMERATED
	{
    DEFAULT_VALUE 14;

		SELECT(sensor_type)	{
			 CASE 0:
					{ 13, "Ohm Single Sensor, 2-wire" },
					{ 14, "Ohm Single Sensor, 3-wire" },
					{ 15, "Ohm Single Sensor, 4-wire" },
					{ 4,  "Ohm Differential, 2-wire" },
					{ 16, "Ohm Avgerage, 2-wire" }

			 CASE 1:
					{ 13, "Pt100 Single Sensor, 2-wire" },
					{ 14, "Pt100 Single Sensor, 3-wire" },
					{ 15, "Pt100 Single Sensor, 4-wire" },
					{ 4,  "Pt100 Differential, 2-wire" },
					{ 16, "Pt100 Avgerage, 2-wire" }

			 CASE 2:
					{ 13, "Ni100 Single Sensor, 2-wire" },
					{ 14, "Ni100 Single Sensor, 3-wire" },
					{ 15, "Ni100 Single Sensor, 4-wire" },
					{ 4,  "Ni100 Differential, 2-wire" },
					{ 16, "Ni100 Avgerage, 2-wire" }

			 CASE 5:
					{ 13, "RTD Single Sensor, 2-wire" },
					{ 14, "RTD Single Sensor, 3-wire" },
					{ 15, "RTD Single Sensor, 4-wire" },
					{ 4,  "RTD Differential, 2-wire" },
					{ 16, "RTD Avgerage, 2-wire" }

			 CASE 128:
					{ 8,  "mV Single Sensor" },
					{ 3,  "mV Differential" },
					{ 12, "mV Avgerage" }

			 DEFAULT:
					{ 5,  "TC Single Sensor, Internal CJC" },
					{ 6,  "TC Single Sensor, External CJC Pt100" },
					{ 7,  "TC Single Sensor, External CJC Ni100" },
					{ 8,  "TC Single Sensor, Constant CJC" },
					{ 0,  "TC Differential, Internal CJC" },
					{ 1,  "TC	Differential, External CJC Pt100" },
					{ 2,  "TC	Differential, External CJC Ni100" },
					{ 3,  "TC Differential, Constant CJC" },
					{ 9,  "TC	Avgerage, Internal CJC" },
					{ 10, "TC Avgerage, External CJC Pt100" },
					{ 11, "TC Avgerage, External CJC Ni100" },
					{ 12, "TC Avgerage, Constant CJC" }
  	}
	}
  POST_EDIT_ACTIONS
  {
    method_sensor_limits
  }
	CLASS DEVICE;
	HANDLING READ & WRITE;
}

VARIABLE meter_option
/*
 * From Table 8 of the Transmitter Specific Document, Rev 01
 */
{
	LABEL [meter_option];
	HELP "Meter option - Defines whether there is a meter installed"
			 " or not and possibly what information the meter will display. ";
	TYPE ENUMERATED
	{
		{ 0,  [none] },
		{ 1,  [degrees_90_linear_scale] },   /* 90 deg linear scale */
		{ 2,  [degrees_90_special_scale] },  /* 90 deg spcl scale */
		{ 3,  [degrees_240_linear_scale] },  /* 240 deg linear scale */
		{ 4,  [degrees_240_special_scale] }, /* 240 deg spcl scale */
		{ 5,  "LCD" }
	}
	CLASS LOCAL_DISPLAY;
	HANDLING READ & WRITE;
}


VARIABLE system_config
/*
 * From Table 9 of the Transmitter Specific Document, Rev 01
 */
{
	LABEL "system configuration";
	HELP "For future use";
	TYPE ENUMERATED
	{
		{ 0,  [not_used] }
	}
	CLASS DEVICE;
	HANDLING READ;
}


VARIABLE const_cjc_value
{
	LABEL "Constant CJC value";
	HELP "Constant CJ temperature value, the actual temperature at the"
			 " junction of the thermocouple wires and the terminals. Units of PV";
	TYPE  FLOAT
	{
		DEFAULT_VALUE 0.0;
    DISPLAY_FORMAT ".2f";
	}
  POST_EDIT_ACTIONS
  {
    method_const_cjc_value
  }
	CLASS DEVICE;
	HANDLING READ & WRITE;
	VALIDITY CONST_CJC;
}

VARIABLE rtd_factor
{
	LABEL "RTD Factor";
	HELP "Multiplication factor for 100 Ohm RTD, reciprocal value, "
			 "e.g. X=2 for Pt50, X=0.1 for Pt1000";
	TYPE  FLOAT
	{
    DEFAULT_VALUE 1.0;
		DISPLAY_FORMAT ".2f";
		EDIT_FORMAT	".4f";
	}
	POST_EDIT_ACTIONS
	{
    method_rtd_factor
  }
	CLASS DEVICE;
	HANDLING READ & WRITE;
	VALIDITY PT_NI;
}

VARIABLE abs_max_value
{
	LABEL "Absolute Maximum Value";
	HELP "Absolute maximum value on individual sensors for differential measurements "
			 "in units of PV";
	TYPE  FLOAT
	{
		DEFAULT_VALUE 0.0;
    DISPLAY_FORMAT ".2f";
		EDIT_FORMAT	".4f";
	}
	POST_EDIT_ACTIONS
	{
    method_sensor_limits
  }
	CLASS DEVICE;
	HANDLING READ & WRITE;
	VALIDITY DIFF_SENS
}

VARIABLE cable_resistance_config
/*
 * From Table 10 of the Transmitter Specific Document, Rev 01
 */
{
	LABEL "Cable Resistance Config";
	HELP "Cable resistance configuration - Configures the cable resistance value";
	TYPE ENUMERATED
	{
    DEFAULT_VALUE 0;
		{ 0,  "Sensor 1" },
		{ 1,  "Sensor 2" },
		{ 2,  "External CJC Sensor" }
	}
	CLASS LOCAL;
	HANDLING READ & WRITE;
}

VARIABLE cable_resistance_value
{
	LABEL "Cable Resistance Value";
	HELP "Cable resistance value in Ohms."
			 " If RTD/Ohm 3 or 4 wire is selected, sensor 1 is the expected max value"
			 " for the total cable resistance in 2 wires, otherwise it is the actual"
			 " total cable resistance.";

	CONSTANT_UNIT [Ohm];
	TYPE  FLOAT
	{
		DEFAULT_VALUE 2.5;
    DISPLAY_FORMAT ".2f";
		EDIT_FORMAT	".4f";
	}
	CLASS DEVICE;
	HANDLING READ & WRITE;
}

VARIABLE current_output_100
{
	LABEL "Analog Output 100%";
	HELP "Output current value at PV = 100%, units of mA";
	CONSTANT_UNIT [mA];

	TYPE  FLOAT
	{
		DEFAULT_VALUE 20.0;
    DISPLAY_FORMAT ".2f";
		EDIT_FORMAT	".4f";
	}
	POST_EDIT_ACTIONS
	{
    method_output_values,
    method_output_limits
	}
	CLASS DEVICE;
	HANDLING READ & WRITE;
}

VARIABLE current_output_0
{
	LABEL "Analog Output 0%";
	HELP "Output current value at PV = 0%, units of mA";
	CONSTANT_UNIT [mA];

	TYPE  FLOAT
	{
		DEFAULT_VALUE 4.0;
		DISPLAY_FORMAT ".2f";
		EDIT_FORMAT	".4f";
	}
	POST_EDIT_ACTIONS
	{
    method_output_values,
    method_output_limits
  }
	CLASS DEVICE;
	HANDLING READ & WRITE;
}


VARIABLE current_output_upper_limit
{
	LABEL "Analog Output Upper Limit";
	HELP "Output current upper limit value, units of mA";
	CONSTANT_UNIT [mA];

	TYPE  FLOAT
	{
		DEFAULT_VALUE 20.5;
		DISPLAY_FORMAT ".2f";
		EDIT_FORMAT	".4f";
	}
	POST_EDIT_ACTIONS
	{
    method_output_limits
  }
	CLASS DEVICE;
	HANDLING READ & WRITE;
}

VARIABLE current_output_lower_limit
{
	LABEL "Analog Output Lower limit";
	HELP "Output current lower limit value, units of mA";
	CONSTANT_UNIT [mA];

	TYPE  FLOAT
	{
		DEFAULT_VALUE 3.8;
		DISPLAY_FORMAT ".2f";
		EDIT_FORMAT	".4f";
	}
	POST_EDIT_ACTIONS
	{
    method_output_limits
  }
	CLASS DEVICE;
	HANDLING READ & WRITE;
}

VARIABLE distributor_name
{
	LABEL	"Distributor Name";
	HELP "Distributor name 32 bit packed ASCII";
	CLASS DEVICE;
	TYPE PACKED_ASCII (32);
	HANDLING READ;
}

VARIABLE oem_data0
{
	LABEL	"OEM data 0";
	HELP "byte undefined OEM data";
	CLASS DEVICE;
	TYPE BIT_ENUMERATED
	{
		{ 1,  "OEM0 bit0" },
		{ 2,  "OEM0 bit1" },
		{ 4,  "OEM0 bit2" },
		{ 8,  "OEM0 bit3" },
		{ 16, "OEM0 bit4" },
		{ 32, "OEM0 bit5" },
		{ 64, "OEM0 bit6" },
		{ 128,"OEM0 bit7" }
	}
	HANDLING READ;
}


VARIABLE oem_data1
{
	LABEL	"OEM data 1";
	HELP "byte undefined OEM data";
	CLASS DEVICE;
	TYPE BIT_ENUMERATED
	{
		{ 1,  "OEM1 bit0" },
		{ 2,  "OEM1 bit1" },
		{ 4,  "OEM1 bit2" },
		{ 8,  "OEM1 bit3" },
		{ 16, "OEM1 bit4" },
		{ 32, "OEM1 bit5" },
		{ 64, "OEM1 bit6" },
		{ 128,"OEM1 bit7" }
	}
	HANDLING READ;
}

VARIABLE oem_data2
{
	LABEL	"OEM data 2";
	HELP "byte undefined OEM data";
	CLASS DEVICE;
	TYPE BIT_ENUMERATED
	{
		{ 1,  "OEM2 bit0" },
		{ 2,  "OEM2 bit1" },
		{ 4,  "OEM2 bit2" },
		{ 8,  "OEM2 bit3" },
		{ 16, "OEM2 bit4" },
		{ 32, "OEM2 bit5" },
		{ 64, "OEM2 bit6" },
		{ 128,"OEM2 bit7" }
	}
	HANDLING READ;
}

VARIABLE sensor_error_code
/*
 * From Table 11 of the Transmitter Specific Document, Rev 01
 */
{
	LABEL "Error Detection";
	HELP "Configures the sensor error detection";
	TYPE ENUMERATED
	{
		DEFAULT_VALUE 0;
    { 0,    "No test performed" },
		{ 1,    "broken sensor" },
		{ 2,    "shorted sensor" },
		{ 3,    "broken and shorted" }
	}
	CLASS DEVICE;
	HANDLING READ & WRITE;
}

VARIABLE shorted_sensor_value
{
	LABEL "Shorted Sensor";
	HELP "Output current value for shorted sensor, units of mA";
	CONSTANT_UNIT [mA];

	TYPE  FLOAT
	{
		DEFAULT_VALUE 3.5;
    DISPLAY_FORMAT ".2f";
		EDIT_FORMAT	".4f";
	}
	POST_EDIT_ACTIONS
	{
    method_broken_shorted
  }
	CLASS DEVICE;
	HANDLING READ & WRITE;
  VALIDITY IF(sensor_error_code == 2 || sensor_error_code == 3) { TRUE; } ELSE { FALSE; }
}

VARIABLE broken_sensor_value
{
	LABEL "Broken Sensor";
	HELP "Output current value for broken sensor, units of mA";
	CONSTANT_UNIT [mA];

	TYPE  FLOAT
	{
		DEFAULT_VALUE 23.0;
		DISPLAY_FORMAT ".2f";
		EDIT_FORMAT	".4f";
	}
	POST_EDIT_ACTIONS
	{
    method_broken_shorted
  }
	CLASS DEVICE;
	HANDLING READ & WRITE;
  VALIDITY IF(sensor_error_code == 1 || sensor_error_code == 3) { TRUE; } ELSE { FALSE; }
}

VARIABLE write_protect_control_code
/*
 * From Table 12 of the Transmitter Specific Document, Rev 01
 */
{
	LABEL "Write protect control code";
	HELP "Enables, disables write protection, or sets new password";
	TYPE ENUMERATED
	{
    { 0,    "Enable write protected" },
		{ 1,    "Disable write protected" },
		{ 2,    "Set new password" }
	}
	CLASS DEVICE;
	HANDLING WRITE;
}

VARIABLE write_protect_password
{
	LABEL	"Enter password";
	HELP "Password for controlling write protection. 8 byte ASCII. No password will be entered as \'********\' ";
	CLASS DEVICE;
	TYPE ASCII (8);
	HANDLING WRITE;
}

VARIABLE new_write_protect_password
{
	LABEL	"New password";
	HELP "New password for controlling write protection. 8 byte ASCII. No password will be entered as \'********\' ";
	CLASS DEVICE;
	TYPE ASCII (8);
	HANDLING WRITE;
}

VARIABLE dummy_write_protect_password
{
	CLASS LOCAL;
	TYPE ASCII (8);
	HANDLING WRITE;
}

VARIABLE max_min_control_code
/*
 * From Table 13 of the Transmitter Specific Document, Rev 01
 */
{
	LABEL "Max/Min control code";
	HELP "Selects read or reset of the data loggin max and min values";
	TYPE ENUMERATED
	{
		{ 0,    "Reset max/min values" },
		{ 1,    "Read max/min values" }
	}
	CLASS LOCAL;
	HANDLING WRITE;
}

VARIABLE max_logged_value
{
	LABEL "Max";
	HELP "Maximum logged PV value, units of PV";

	TYPE  FLOAT
	{
		DISPLAY_FORMAT ".4f";
	}
	CLASS LOCAL;
	HANDLING READ;
}

VARIABLE min_logged_value
{
	LABEL "Min";
	HELP "Minimum logged PV value, units of PV";

	TYPE  FLOAT
	{
		DISPLAY_FORMAT ".4f";
	}
	CLASS LOCAL;
	HANDLING READ;
}


VARIABLE expanded_serial_number
{
	LABEL "Serial Number";
	HELP	"9 digit production line serial number"
		", consisting of yybbbrrrr, where <yy>"
		" is the year of production, <bbb> is"
		" the batch number and <rrrr> is a running"
		" number for this batch. Expanded from device id";
	TYPE  UNSIGNED_INTEGER (4)
	{
		DISPLAY_FORMAT "09u";
	}
	CLASS LOCAL;
	HANDLING READ;
}


COLLECTION OF VARIABLE temperature
{
	LABEL [temperature];
	HELP "Collection of variable for Temperature Transmitter";
	MEMBERS
	{
		DIGITAL_UNITS, pv_digital_units, [units], [digital_units_help];
		DIGITAL_VALUE, pv_digital_value, [blank], [digital_value_help];
		ANALOG_VALUE, analog_value, [analog_output_value];
		PERCENT_RANGE, percent_range, [percent_of_range];

		SENSOR_UNITS, sensor_limit_units, [sensor_unit];
		UPPER_SENSOR_LIMIT, atemperature_upper_sensor_limit, [usl], [upper_sensor_limit_help];
		LOWER_SENSOR_LIMIT, atemperature_lower_sensor_limit, [lsl], [lower_sensor_limit_help];
		MINIMUM_SPAN, atemperature_minimum_span, [minimum_span];
		SENSOR_SERIAL_NUMBER, atemperature_sensor_serial_number, [sensor_serial_number], [sensor_serial_number_help];

		ALARM_CODE, alarm_select, [alarm_select];
		UPPER_RANGE_VALUE, upper_range_value, [urv], [upper_range_value_help];
		LOWER_RANGE_VALUE, lower_range_value, [lrv], [lower_range_value_help];
		DAMPING_VALUE, damping_value, [damping_value];
		TRANSFER_FUNCTION, atransfer_function, [transfer_function];
		RANGE_UNITS, pv_digital_units, [range_units];
	}
}

COLLECTION OF VARIABLE sensor1_temperature
{
	LABEL [sensor_one_temperature];
	HELP "Collection of variable for Sensor 1 Temperature";
	MEMBERS
	{
		DIGITAL_UNITS, sensor1_units, [units];
		DIGITAL_VALUE, sensor1_digital_value, [blank];
	}
}

COLLECTION OF VARIABLE sensor2_temperature
{
	LABEL [sensor_two_temperature];
	HELP "Collection of variable for Sensor 2 Temperature";
	MEMBERS
	{
		DIGITAL_UNITS, sensor2_units, [units];
		DIGITAL_VALUE, sensor2_digital_value, [blank];
	}
}


COLLECTION OF VARIABLE electr_temperature
{
	LABEL "Electr/CJC temp";
	HELP "Collection of variable for electronics or CJC temperature";
	MEMBERS
	{
		DIGITAL_UNITS, cjc_electr_sensor_units, [units];
		DIGITAL_VALUE, cjc_electr_sensor_digital_value, [blank];
	}
}

ARRAY OF COLLECTION dynamic_variables
{
	ELEMENTS
	{
		PRIMARY,   temperature,           [pv], "Primary Variable Temperature";
		SECONDARY, sensor1_temperature,   [sv], [sensor_one_temperature];
		TERTIARY,  sensor2_temperature,   [tv], [sensor_two_temperature];
		FOURTH,    electr_temperature, 		[qv], "Electr/CJC temp";
	}
}


ARRAY OF VARIABLE loop_warning_variables
{
		ELEMENTS
		{
			0,upper_range_value;
			1,lower_range_value;
			2,damping_value;
			3,sensor_type;
			4,measurement_type;
			5,const_cjc_value;
			6,rtd_factor;
			7,abs_max_value;
			8,current_output_100;
			9,current_output_0;
			10,current_output_upper_limit;
			11,current_output_lower_limit;
			12,sensor_error_code;
			13,shorted_sensor_value;
			14,broken_sensor_value;
		}
}



COMMAND read_config_data
{
	NUMBER 140;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{}
		REPLY
		{
			response_code, device_status,
			sensor_type,
			measurement_type,
			meter_option,
			system_config,
			const_cjc_value,
			rtd_factor,
			abs_max_value
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,             [no_command_specific_errors];
		6,	MISC_ERROR,		       [xmtr_specific_command_error];
	}
}


COMMAND Write_config_data
{
	NUMBER 141;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			sensor_type,
			measurement_type,
			meter_option,
			system_config,
			const_cjc_value,
			rtd_factor,
			abs_max_value
		}
		REPLY
		{
			response_code, device_status,
			sensor_type,
			measurement_type,
			meter_option,
			system_config,
			const_cjc_value,
			rtd_factor,
			abs_max_value
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,             [no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,    [invalid_selection];
		5,  MISC_ERROR,          [too_few_data_bytes_recieved];
		6,	MISC_ERROR,		       [xmtr_specific_command_error];
		7,  MODE_ERROR,          [in_write_protect_mode];
		9,  DATA_ENTRY_ERROR,    "constant CJC value too low";
		10, DATA_ENTRY_ERROR,    "RTD factor too high";
		11, DATA_ENTRY_ERROR,    "constant CJC value too high";
		12, DATA_ENTRY_ERROR,    "RTD factor too low";
	}
}


COMMAND read_cable_resistance
{
	NUMBER 142;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
			cable_resistance_config
		}
		REPLY
		{
			response_code, device_status,
			cable_resistance_config,
			cable_resistance_value
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,             [no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,    [invalid_selection];
		5,  MISC_ERROR,          [too_few_data_bytes_recieved];
		6,	MISC_ERROR,		       [xmtr_specific_command_error];
	}
}


COMMAND Write_cable_resistance
{
	NUMBER 143;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			cable_resistance_config,
			cable_resistance_value
		}
		REPLY
		{
			response_code, device_status,
			cable_resistance_config,
			cable_resistance_value
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,             [no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,    [invalid_selection];
		5,  MISC_ERROR,          [too_few_data_bytes_recieved];
		6,	MISC_ERROR,		       [xmtr_specific_command_error];
		7,  MODE_ERROR,          [in_write_protect_mode];
		9,  DATA_ENTRY_ERROR,    "Cable resistance value too high";
	}
}



COMMAND read_current_output_range_values
{
	NUMBER 146;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{}
		REPLY
		{
			response_code, device_status,
			current_output_100,
			current_output_0,
			current_output_upper_limit,
			current_output_lower_limit
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,             [no_command_specific_errors];
		6,	MISC_ERROR,		       [xmtr_specific_command_error];
	}
}


COMMAND Write_current_output_range_values
{
	NUMBER 147;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			current_output_100,
			current_output_0,
			current_output_upper_limit,
			current_output_lower_limit
		}
		REPLY
		{
			response_code, device_status,
			current_output_100,
			current_output_0,
			current_output_upper_limit,
			current_output_lower_limit
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,             [no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,    [invalid_selection];
		5,  MISC_ERROR,          [too_few_data_bytes_recieved];
		6,	MISC_ERROR,		       [xmtr_specific_command_error];
		7,  MODE_ERROR,          [in_write_protect_mode];
		9,  DATA_ENTRY_ERROR,    "100% current value too high";
		10, DATA_ENTRY_ERROR,    "0% current value too low";
		11, DATA_ENTRY_ERROR,    "upper current limit value too high";
		12, DATA_ENTRY_ERROR,    "lower current limit value too low";
	}
}


COMMAND read_distributor_name
{
	NUMBER 148;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{}
		REPLY
		{
			response_code, device_status,
			distributor_name
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,             [no_command_specific_errors];
		6,	MISC_ERROR,		       [xmtr_specific_command_error];
	}
}


COMMAND read_oem_data
{
	NUMBER 149;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{}
		REPLY
		{
			response_code, device_status,
			oem_data0,
			oem_data1,
			oem_data2
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,             [no_command_specific_errors];
		6,	MISC_ERROR,		       [xmtr_specific_command_error];
	}
}


COMMAND read_sensor_error_values
{
	NUMBER 150;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{}
		REPLY
		{
			response_code, device_status,
			sensor_error_code,
			shorted_sensor_value,
			broken_sensor_value
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,             [no_command_specific_errors];
		6,	MISC_ERROR,		       [xmtr_specific_command_error];
	}
}


COMMAND Write_sensor_error_values
{
	NUMBER 151;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			sensor_error_code,
			shorted_sensor_value,
			broken_sensor_value
		}
		REPLY
		{
			response_code, device_status,
			sensor_error_code,
			shorted_sensor_value,
			broken_sensor_value
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,             [no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,    [invalid_selection];
		5,  MISC_ERROR,          [too_few_data_bytes_recieved];
		6,	MISC_ERROR,		       [xmtr_specific_command_error];
		7,  MODE_ERROR,          [in_write_protect_mode];
		9,  DATA_ENTRY_ERROR,    "shorted sensor value too high";
		10, DATA_ENTRY_ERROR,    "shorted sensor value too low";
		11, DATA_ENTRY_ERROR,    "broken sensor value too high";
		12, DATA_ENTRY_ERROR,    "broken sensor value too low";
	}
}


COMMAND write_protect_setup
{
	NUMBER 152;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			write_protect_control_code,
			write_protect_password,
			new_write_protect_password
		}
		REPLY
		{
			response_code, device_status,
			write_protect_control_code,
			write_protect_password,
			new_write_protect_password
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,             [no_command_specific_errors];
		1,	DATA_ENTRY_ERROR,    "incorrect password";
		5,  MISC_ERROR,          [too_few_data_bytes_recieved];
		6,	MISC_ERROR,		       [xmtr_specific_command_error];
	}
}


COMMAND read_reset_max_min
{
	NUMBER 153;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
			max_min_control_code
		}
		REPLY
		{
			response_code, device_status,
			max_min_control_code,
			max_logged_value,
			min_logged_value
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,             [no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,    [invalid_selection];
		5,  MISC_ERROR,          [too_few_data_bytes_recieved];
		7,  MODE_ERROR,          [in_write_protect_mode];
	}
}


COMMAND reset_dac_trim
{
	NUMBER 154;
	OPERATION COMMAND;
	TRANSACTION
	{
		REQUEST
		{}
		REPLY
		{
			response_code, device_status
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,             [no_command_specific_errors];
		6,	MISC_ERROR,		       [xmtr_specific_command_error];
		7,  MODE_ERROR,          [in_write_protect_mode];
	}
}

/*******************************************************************************/
/*****	MENU Bar : Maintenance *************************************************/
/*******************************************************************************/
MENU Menu_Main_Maintenance
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		Menu_M_Device,
		Menu_M_View,
		Menu_M_Options,
		Menu_Help
	}
}

MENU Menu_M_Device
{
	LABEL		[menu_Device];
	ITEMS
	{
		std_LoadinDevice,										
		std_LoadinPC											
	}
}

MENU Menu_M_View
{
	LABEL		[menu_View];
	ITEMS
	{
		OnlineWindow_display,
		//OnlineWindow_yt,
		OnlineWindow_yt2,
		OnlineWindow_diagnosis,
		SEPARATOR,
		std_Funktionsleiste,
		std_Statuszeile,
		SEPARATOR,
		std_Update
	}
}

/*******************************************************************************/
/*****	MENU Bar : Specialist **************************************************/
/*******************************************************************************/
MENU Menu_Main_Specialist
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		Menu_S_Device,
		Menu_S_View,
		Menu_S_Options,
		Menu_Help
	}
}

MENU Menu_S_Device
{
	LABEL		[menu_Device];
	ITEMS
	{
//		std_NodeAddress,
//		SEPARATOR,
		std_LoadinDevice,										
		std_LoadinPC,
		SEPARATOR,
		read_max_min,
		reset_max_min,
		SEPARATOR,
		show_serial_number
		SEPARATOR,
		Menu_S_WriteProtect,
		Menu_S_Input,
		Menu_S_Output,
		Menu_S_DacTrim,
		SEPARATOR,
		MENU_s_HART
	}
}

MENU Menu_S_View
{
	LABEL		[menu_View];
	ITEMS
	{
		OnlineWindow_display,
		//OnlineWindow_yt,
		OnlineWindow_yt2
		OnlineWindow_diagnosis,
		SEPARATOR,
		std_Funktionsleiste,
		std_Statuszeile,
		SEPARATOR,
		std_Update
	}
}


MENU Menu_S_WriteProtect
{
	LABEL	"Write Protection";
	ITEMS
	{
    write_protect_on,
    write_protect_off,
    SEPARATOR,
    set_new_password
	}
}

MENU Menu_S_Input
{
	LABEL	"Input";
	ITEMS
	{
    enter_sensor_configuration,
    SEPARATOR,
    enter_cable_resistance,
    measure_cable_resistance
	}
}

MENU Menu_S_Output
{
	LABEL	"Output";
	ITEMS
	{
    broken_namur_down,
    broken_namur_up,
    SEPARATOR,
    shorted_namur_down,
    shorted_namur_up,
    SEPARATOR,
    set_output_limits_namur
	}
}

MENU Menu_S_DacTrim
{
	LABEL	"Dac Trim";
	ITEMS
	{
    loop_test,
    SEPARATOR,
    dac_trim,
    scaled_dac_trim,
    override_dac_trim
	}
}

/*
METHOD std_NodeAddress
{
	LABEL		[menu_Device_NodeAddress];
	DEFINITION
	{
	}
}
*/
METHOD std_LoadinDevice
{
	LABEL		[menu_Device_LoadinDevice];
	DEFINITION
	{
	}
}

METHOD std_LoadinPC
{
	LABEL		[menu_Device_LoadinPC];
	DEFINITION
	{
	}
}

METHOD std_Funktionsleiste
{
	LABEL		[menu_View_Toolbar];
	DEFINITION
	{
	}
}

METHOD std_Statuszeile
{
	LABEL		[menu_View_Statusbar];
	DEFINITION
	{
	}
}

METHOD std_Update
{
	LABEL		[menu_View_Update];
	DEFINITION
	{
	}
}

/*******************************************************************************/
/*****	Online Window : Display ************************************************/
/*******************************************************************************/
MENU OnlineWindow_display
{
	LABEL		[menu_dialog_display];
	ITEMS
	{
		Page_display_out,
		Page_display_measure,
		Page_display_secondary
	}
}

MENU Page_display_out
{
//	LABEL		[menu_dialog_display_output];
	LABEL		"Output" 	"|de|Ausgang";
	

	ITEMS
	{

		BarVal_out_display,
		analog_value	(READ_ONLY)
	}
}

MENU BarVal_out_display
{
	LABEL		"Output Value";
	ITEMS
	{
		analog_value				(READ_ONLY),
		current_output_lower_limit	(READ_ONLY),
		current_output_upper_limit	(READ_ONLY)
	}
}

MENU Page_display_measure
{
	LABEL		[menu_dialog_display_measure];
	ITEMS
	{
		Group_primary,
		Group_measure_1,
		Group_measure_2,
		Group_measure_3
	}
}

MENU Group_primary
{
	LABEL		"Primary Value";
	ITEMS
	{
		pv_digital_value
	}
}

MENU Group_measure_1
{
	LABEL		"Sensor 1 Value";
	ITEMS
	{
		sensor1_digital_value
	}
}

MENU Group_measure_2
{
	LABEL		"Sensor 2 Value";
	ITEMS
	{
		sensor2_digital_value
	}
}

MENU Group_measure_3
{
	LABEL		"Internal Temperature / CJC temperature";
	ITEMS
	{
		cjc_electr_sensor_digital_value
	}
}

MENU Page_display_secondary
{
	LABEL		"Secondary";
	ITEMS
	{
		Group_display_secondary,
/*		trans1_RJ_TEMP*/
	}
}

MENU Group_display_secondary
{
	LABEL		"Device Status";
	ITEMS
	{
		sensor_error_code	(READ_ONLY),
		xmtr_specific_status_0,
		xmtr_specific_status_1,
		xmtr_specific_status_2
	}
}

/*******************************************************************************/
/*****	Online Window : yt *****************************************************/
/*******************************************************************************/
MENU OnlineWindow_yt2
{
	LABEL		[menu_yt_diagram] ;
	STYLE 		WINDOW;
	ACCESS 		ONLINE;
	ITEMS
	{
		ValueChart_page
	}
}

MENU ValueChart_page
{
	LABEL 	"Y t diagram";
	STYLE 	PAGE;
	ACCESS	ONLINE;
	ITEMS
	{
		Val_AO,
		Val_PV,
		Val_SV,
		Val_TV,
		Val_FV,
		ChartStrip_MainPV
	}
}
CHART ChartStrip_MainPV
{
	LABEL		"Output Value";
	TYPE       	STRIP;
	WIDTH      	LARGE;
	HEIGHT     	MEDIUM;
	CYCLE_TIME 	CYCLE_TIME_PV_CHART;
	LENGTH     	180000;    /* 3 minutes */
	MEMBERS
	{
		MainAO_VALUE,		MainAO_value;
		MainPV_VALUE,		MainPV_value;
	}
}

SOURCE MainAO_value
{
	Y_AXIS	AO_axis;
	MEMBERS
	{
			MONITOR1,analog_value;
  }
}
AXIS AO_axis
{
	MIN_VALUE    current_output_lower_limit;
	MAX_VALUE    current_output_upper_limit;
}

SOURCE MainPV_value
{
	Y_AXIS	PV_axis;
	MEMBERS
	{
			MONITOR1,pv_digital_value;
			MONITOR2,sensor1_digital_value;
			MONITOR3,sensor2_digital_value;
			MONITOR4,cjc_electr_sensor_digital_value;
  }
}

AXIS PV_axis
{
	MIN_VALUE    lower_range_value;
	MAX_VALUE    upper_range_value;
}

MENU Val_AO
{
  LABEL		"Output Value";
	STYLE		"OCX_DYNAMIC_YT";
	ITEMS
	{
		analog_value
	}
}

MENU Val_PV
{
  LABEL		"Primary Value";
	STYLE		"OCX_DYNAMIC_YT";
	ITEMS
	{
		pv_digital_value,
	}
}

MENU Val_SV
{
  LABEL		"Sensor 1 Value";
	STYLE		"OCX_DYNAMIC_YT";
	ITEMS
	{
		sensor1_digital_value
	}
}

MENU Val_TV
{
  LABEL		"Sensor 2 Value";
	STYLE		"OCX_DYNAMIC_YT";
	ITEMS
	{
		sensor2_digital_value
	}
}

MENU Val_FV
{
	LABEL		"Internal Temperature / CJC temperature";
	STYLE		"OCX_DYNAMIC_YT";
	ITEMS
	{
		cjc_electr_sensor_digital_value
	}
}

/*******************************************************************************/
/*****	Online Window : Diagnosis **********************************************/
/*******************************************************************************/
MENU OnlineWindow_diagnosis
{
	LABEL		[menu_dialog_diagnosis];
	ITEMS
	{
		Page_diagnosis_general,
	}
}

MENU Page_diagnosis_general
{
	LABEL		[menu_dialog_general];
	ITEMS
	{
		tag			(READ_ONLY),
		message			(READ_ONLY),
		descriptor		(READ_ONLY),
		manufacturer_id,
		device_type,
		universal_revision,
		transmitter_revision,
		software_revision,
		hardware_revision,
		write_protect,
		final_assembly_number	(READ_ONLY),
		date			(READ_ONLY),
		xmtr_specific_status_0,
		xmtr_specific_status_1,
		xmtr_specific_status_2
	}
}

MENU download_variables
{
	LABEL "read_variables";

	ITEMS
	{
		tag,
		descriptor,
		message,
		manufacturer_id,
		device_type,
		universal_revision,
		transmitter_revision,
		software_revision,
		hardware_revision,
		write_protect,
		final_assembly_number,
		date,
		pv_digital_units,
		damping_value,
		sensor_type,
		measurement_type,
		const_cjc_value,
		rtd_factor,
		lower_range_value,
		upper_range_value,
		current_output_100,
		current_output_0,
		current_output_upper_limit,
		current_output_lower_limit,
		sensor_error_code,
		shorted_sensor_value,
		broken_sensor_value,
		atemperature_lower_sensor_limit,
		atemperature_upper_sensor_limit,
		atemperature_minimum_span
	}
}

MENU upload_variables
{
	LABEL "write_variables";

	ITEMS
	{
		tag,
		message,
		descriptor,
		final_assembly_number,
		date,
		pv_digital_units,
		damping_value,
		sensor_type,
		measurement_type,
		const_cjc_value,
		rtd_factor,
		abs_max_value,
		lower_range_value,
		upper_range_value,
		current_output_100,
		current_output_0,
		current_output_upper_limit,
		current_output_lower_limit,
		sensor_error_code,
		shorted_sensor_value,
		broken_sensor_value
	}
}

/*******************************************************************************/
/*****	Table: Specialist  *****************************************************/
/*******************************************************************************/
MENU Table_Main_Specialist
{
	LABEL	MAIN_LABEL;
	ITEMS
	{
		Table2_s_Identification,
		Table2_s_Input,
		Table2_s_Output//,
  //  Table2_s_HART
	}
}

MENU Table2_s_Identification
{
	LABEL	[menu_ident];
	ITEMS
	{
		Tab3_s_id_operation_unit,
		Tab3_s_id_device
	}
}

MENU Table2_s_Input
{
	LABEL	[menu_input];
	ITEMS
	{
		pv_digital_units,
    sensor_type,
    measurement_type,
    rtd_factor,
		const_cjc_value,
		abs_max_value,
		Table3_s_Measure,
		Table3_s_PVScale
	}
}

MENU Table2_s_Output
{
	LABEL	[menu_output];
	ITEMS
	{
    Table3_s_AOutput,
    Table3_s_SError,
    Table3_s_Damping
	}
}

MENU MENU_s_HART
{
	LABEL	"HART";
	ITEMS
	{
		polling_address (DISPLAY_VALUE),
		request_preambles (DISPLAY_VALUE),
		response_preambles (DISPLAY_VALUE)
	}
}

MENU Table3_s_Measure
{
  LABEL "Sensor Limits";
  ITEMS
  {
		atemperature_lower_sensor_limit,
		atemperature_upper_sensor_limit,
		atemperature_minimum_span
  }
}

MENU Table3_s_PVScale
{
  LABEL "Process Value Scale";
  ITEMS
  {
		lower_range_value,
		upper_range_value
  }
}

MENU Table3_s_AOutput
{
  LABEL [analog_output];
  ITEMS
  {
		current_output_0,
		current_output_100,
		current_output_lower_limit,
		current_output_upper_limit
  }
}

MENU Table3_s_SError
{
  LABEL "Sensor Error";
  ITEMS
  {
    sensor_error_code,
		broken_sensor_value,
		shorted_sensor_value
  }
}

MENU Table3_s_Damping 
{
  LABEL "Damping";
  ITEMS
  {
		damping_value,
  }
}

MENU Tab3_s_id_operation_unit
{
	LABEL		[menu_ident_opunit];
	ITEMS
	{
		tag,
		descriptor,	
		message	
	}
}

MENU Tab3_s_id_device
{
	LABEL		[menu_ident_device];
	ITEMS
	{
		manufacturer_id,
		device_type,
    universal_revision,
    transmitter_revision,
		software_revision,
		hardware_revision,
		write_protect,
		final_assembly_number,
		date
	}
}

/*******************************************************************************/
/*****	Table: Maintenance  ****************************************************/
/*******************************************************************************/

MENU Table_Main_Maintenance
{
	LABEL	MAIN_LABEL;
	ITEMS
	{
		Table2_m_Identification
	}
}

MENU Table2_m_Identification
{
	LABEL		[menu_ident];
	ITEMS
	{
		Tab3_m_id_operation_unit,
		Tab3_m_id_device
	}
}

MENU Tab3_m_id_operation_unit
{
	LABEL		[menu_ident_opunit];
	ITEMS
	{
		tag (READ_ONLY),
		descriptor (READ_ONLY),	
		message (READ_ONLY)	
	}
}

MENU Tab3_m_id_device
{
	LABEL		[menu_ident_device];
	ITEMS
	{
		manufacturer_id,
		device_type,
    universal_revision,
    transmitter_revision,
		software_revision,
		hardware_revision,
		write_protect,
		final_assembly_number (READ_ONLY),
		date (READ_ONLY)
	}
}

/*******************************************************************************/
/*****	Methods  ***************************************************************/
/*******************************************************************************/
METHOD put_in_manual
{
	LABEL "Loop in manual";
	DEFINITION
	{
		char disp_string1[60];
		int slen1;
		slen1 = 60;
		get_dictionary_string(remove_loop_from_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
	}
}


METHOD back_to_normal
{
	LABEL "Back to normal";
	DEFINITION
	{
		ACKNOWLEDGE("Note: Loop may be returned to automatic control when SEND is done");
	}
}


METHOD read_max_min
{
	LABEL "Read max/min log";
	HELP	"Reads the maximum and minimum logged values";
	DEFINITION
	{
		char status[STATUS_SIZE];
		long varid[4];

		IGNORE_ALL_RESPONSE_CODES();
		assign_int(max_min_control_code,1);
		send(153,status);
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(153,status[STATUS_RESPONSE_CODE]);
			process_abort();
		}
		varid[0] =VARID(min_logged_value);
		varid[1] =VARID(max_logged_value);
		varid[2] =VARID(pv_digital_units);
		delay(10,"\nMin logged value:\n   %{0} %{2} \n\nMax logged value:\n   %{1} %{2} ",varid);
	}
}


METHOD reset_max_min
{
	LABEL "Reset max/min log";
	HELP	"Resets the maximum and minimum logged values";
	DEFINITION
	{
		char status[STATUS_SIZE];

		ACKNOWLEDGE("Reset the primary variable maximum and minimum logged values to actual measured value?");
		IGNORE_ALL_RESPONSE_CODES();
		assign_int(max_min_control_code,0);
		send(153,status);
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(153,status[STATUS_RESPONSE_CODE]);
			process_abort();
		}
		DELAY(3,"Logged values is reset.");
	}
}

METHOD write_protect_on
{

	LABEL "Write protect";
	HELP	"Write protects the device, if correct password is entered";
	VALIDITY IF(write_protect==0) { TRUE; } ELSE { FALSE; }
	DEFINITION
	{
		char status[STATUS_SIZE];
		int choice;

		IGNORE_ALL_RESPONSE_CODES();
		assign_var(write_protect_password,dummy_write_protect_password);


		GET_DEV_VAR_VALUE("Enter correct password (ENTER if none):",write_protect_password);
		assign_int(write_protect_control_code,0);
		send(152,status);
		if (status[STATUS_RESPONSE_CODE]==0)
		{
			ACKNOWLEDGE("Device write protected");
		}
		else
		{
			display_response_status(152,status[STATUS_RESPONSE_CODE]);
		}
		send(15,status);
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(15,status[STATUS_RESPONSE_CODE]);
			process_abort();
		}
	}
}


METHOD write_protect_off
{

	LABEL "Write enable";
	HELP	"Write enables the device, if correct password is previously entered";
	VALIDITY IF(write_protect==1) { TRUE; } ELSE { FALSE; }
	DEFINITION
	{
		char status[STATUS_SIZE];
		int choice;

		IGNORE_ALL_RESPONSE_CODES();
		assign_var(write_protect_password,dummy_write_protect_password);
		GET_DEV_VAR_VALUE("Enter correct password (ENTER if none):",write_protect_password);

		assign_int(write_protect_control_code,1);
		send(152,status);
		if (status[STATUS_RESPONSE_CODE]==0)
		{
			ACKNOWLEDGE("Device NOT write protected");
		}
		else
		{
			display_response_status(152,status[STATUS_RESPONSE_CODE]);
		}
		send(15,status);
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(15,status[STATUS_RESPONSE_CODE]);
			process_abort();
		}
	}
}


METHOD set_new_password
{
	LABEL "New password";
	HELP	"Sets a new password for write protection, if correct password is entered";
	DEFINITION
	{
		char status[STATUS_SIZE];
		long varid[2];

		IGNORE_ALL_RESPONSE_CODES();
		assign_var(new_write_protect_password,dummy_write_protect_password);
		assign_var(write_protect_password,dummy_write_protect_password);

		GET_DEV_VAR_VALUE("Enter correct password (ENTER if none):",write_protect_password);
		GET_DEV_VAR_VALUE("Enter new password (ENTER if none):",new_write_protect_password);

		varid[0]=VARID(new_write_protect_password);
		acknowledge("Change password to: %{0}",varid);

		assign_int(write_protect_control_code,2);
		send(152,status);
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(152,status[STATUS_RESPONSE_CODE]);
			process_abort();
		}
		acknowledge("Password changed %{0}",varid);
	}
}


METHOD show_serial_number
{
	LABEL "Serial Number";
	HELP	"9 digit production line serial number"
		", consisting of yybbbrrrr, where <yy>"
		" is the year of production, <bbb> is"
		" the batch number and <rrrr> is a running"
		" number for this batch. Expanded from device id";	DEFINITION
	{
		long sernum;
		long year;
		long varid[1];


		IGNORE_ALL_RESPONSE_CODES();

		sernum=ivar_value(device_id);
		year=sernum/100000;
		year=year*100000;
		sernum=sernum-year+900000;
		year=year*100;
		sernum=year+sernum;
		iassign(expanded_serial_number,sernum);
//		GET_DEV_VAR_VALUE("Serial Number:",expanded_serial_number);
		
		varid[0] =VARID(expanded_serial_number);

		acknowledge("Serial Number: %{0}" ,varid );
		
	}
}

METHOD enter_sensor_configuration
{
	LABEL "Sensor Configuration";
	HELP	"Configures the sensor, sensor type, measurement type, CJC compensation etc.";
	DEFINITION
	{

		char status[STATUS_SIZE];
		char disp_string1[60];
		int choice;
		int val_flag;
		int slen1;
		long varid[4];


		IGNORE_ALL_RESPONSE_CODES();

		slen1 = 60;


		get_dictionary_string(remove_loop_from_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		add_abort_method(return_to_normal);

		send(140,status);

		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(140,status[STATUS_RESPONSE_CODE]);
			process_abort();
		}

		GET_DEV_VAR_VALUE("Enter sensor type:",sensor_type);


		switch(ivar_value(sensor_type))
		{
			case 0:
				assign_int(pv_digital_units,37);
				break;
			case 128:
				assign_int(pv_digital_units,36);
				break;
			default:
				GET_DEV_VAR_VALUE("Enter primary variable units:",pv_digital_units);
		}

		send(44,status);

		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(44,status[STATUS_RESPONSE_CODE]);
			process_abort();
		}

		if(ivar_value(sensor_type)<128)		/* Ohm/RTD	*/
		{
			choice =	SELECT_FROM_LIST("Enter number of sensor wires:","2-wire;3-wire;4-wire;2-wire diff;2-wire average");

			if(ivar_value(sensor_type)>0)
			{
				GET_DEV_VAR_VALUE("Enter RTD factor:",rtd_factor);
			}

			switch ( choice )
			{
				case 0:
					assign_int(measurement_type,13);		/* sgl 2-wire */
					break;
				case 1:
					assign_int(measurement_type,14);		/* sgl 3-wire */
					break;
				case 2:
					assign_int(measurement_type,15);		/* sgl 4-wire */
					break;
				case 3:
					assign_int(measurement_type,4);		/* diff 2-wire */
					break;
				case 4:
					assign_int(measurement_type,16);		/* avg 2-wire */
					break;


				default:
					ACKNOWLEDGE("choice >4");
					process_abort();
			}
		}
		else	/* mV/TC */
		{
			choice =	SELECT_FROM_LIST("Enter measurement type:","Single;Differential;Average");

			switch ( choice )
			{
				case 0:
					assign_int(measurement_type,5);		/* single TC/mV int cjc */
					break;
				case 1:
					assign_int(measurement_type,0);		/* diff TC/mV int cjc */
					break;
				case 2:
					assign_int(measurement_type,9);		/* avg TC/mV int cjc */
					break;
				default:
					ACKNOWLEDGE("choice >2");
					process_abort();
			}
		}

		val_flag=0;
		if(ivar_value(sensor_type)>128)		/* TC */
		{
			choice =	SELECT_FROM_LIST("Enter cold junction compensation:","Internal sensor;External Pt100;External Ni100;Constant (none)");
			assign_int(measurement_type,ivar_value(measurement_type)+choice);
			if (choice == 3)
			{
				GET_DEV_VAR_VALUE("Enter constant CJC temperature:",const_cjc_value);
				val_flag=1;
			}
		}
		if (val_flag==0)
		{
			switch (ivar_value(pv_digital_units))
			{
				case 33:          								 /* degrees Fahrenheit */
					assign_float(const_cjc_value,32);
					break;
				case 34:          								 /* degrees Rankine */
					assign_float(const_cjc_value,49167e-2);
					break;
				case 35:          								 /* Kelvin */
					assign_float(const_cjc_value,27315e-2);
					break;
				default:                           /* degrees Celcius */
					assign_float(const_cjc_value,0);
			}
		}


		if (ivar_value(measurement_type)<5)
		{
			GET_DEV_VAR_VALUE("Enter highest possible value on each sensor:",abs_max_value);
		}


		send(141,status);

		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(141,status[STATUS_RESPONSE_CODE]);
			process_abort();
		}

		DELAY(3,"Wait, sending configuration...");
		send(15,status);

		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(15,status[STATUS_RESPONSE_CODE]);
			ACKNOWLEDGE("Note: Range values is set to default"
									" for the chosen sensor type.");
			process_abort();
		}

		varid[0] =VARID(lower_range_value);
		varid[1] =VARID(upper_range_value);
		varid[2] =VARID(pv_digital_units);
		acknowledge("Note:\n"
								"Lower range value set to: %{0} %{2} \n"
								"Upper range value set to: %{1} %{2}",varid);

		send(14,status);

		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(14,status[STATUS_RESPONSE_CODE]);
			process_abort();
		}
		process_abort();
	}
}



METHOD enter_cable_resistance
{
/*
prompt the user "enter cable resistance for sensor1"
input cable_resistance_value
assign 0 to cable_resistance_config
send command 143
if responsecode abort method
*/

	LABEL "Enter Cable Resistance";
	HELP	"Enter new value for cable resistance. "
				"If the device setup is RTD/Ohm 3 or 4 wire, cable resistance for sensor 1 is the expected max value "
				"for the total cable resistance in 2 wires. Otherwise it is the actual "
				"total cable resistance for the selected sensor";
	VALIDITY CAB_RES
	DEFINITION
	{

		char status[STATUS_SIZE];
		char disp_string1[60];
		int sensor_select;
		int meas_val;
		int slen1;

		IGNORE_ALL_RESPONSE_CODES();

		slen1 = 60;
		meas_val = ivar_value(measurement_type);
		sensor_select = 3;
		switch ( meas_val )
		{
			case 1:
				sensor_select = 2;
				break;

			case 2:
				sensor_select = 2;
				break;

			case 4:
				sensor_select = 3;
				break;

			case 6:
				sensor_select = 2;
				break;

			case 7:
				sensor_select = 2;
				break;

			case 10:
				sensor_select = 2;
				break;

			case 11:
				sensor_select = 2;
				break;

			case 13:
				sensor_select = 0;
				break;

			case 14:
				sensor_select = 0;
				break;

			case 15:
				sensor_select = 0;
				break;

			case 16:
				sensor_select = 3;
				break;

			default:
			process_abort();
		}

		if(sensor_select==3)
		{
			sensor_select =	SELECT_FROM_LIST("Enter cable resistance for:","sensor1;sensor2");
		}
		get_dictionary_string(remove_loop_from_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		add_abort_method(return_to_normal);

		assign_int(cable_resistance_config,sensor_select);

		send(142,status);

		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(142,status[STATUS_RESPONSE_CODE]);
			process_abort();
		}

		switch (sensor_select)
		{
			case 0:
					GET_DEV_VAR_VALUE("Enter cable resistance for sensor1:",cable_resistance_value);
				break;

			case 1:
					GET_DEV_VAR_VALUE("Enter cable resistance for sensor2:",cable_resistance_value);
				break;

			case 2:
					GET_DEV_VAR_VALUE("Enter cable resistance for external CJC sensor:",cable_resistance_value);
				break;

			default:
				break;

		}

		send(143,status);
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(143,status[STATUS_RESPONSE_CODE]);
			process_abort();
		}
		process_abort();
	}
}

METHOD measure_cable_resistance
{
	LABEL "Measure Cable Resistance";
	HELP	"Automaticly measures the cable resistance. "
				"If the device setup is RTD/Ohm 3 or 4 wire, cable resistance for sensor 1 is the expected max value "
				"for the total cable resistance in 2 wires. Otherwise it is the actual "
				"total cable resistance for the selected sensor";
	VALIDITY CAB_RES
	DEFINITION
	{

		float stored_upper_range_value;
		float stored_lower_range_value;
		float	stored_damping_value;
		float	stored_cable_resistance1;
		float	stored_const_cjc_value;
		int stored_pv_digital_units;
		int stored_sensor_type;
		int stored_measurement_type;
		int stored_sensor_error_code;


		float fix_cur_value;

		int com_error;
		int choice;
		int sensor_select;


		char status[STATUS_SIZE];
		char disp_string1[60];
		int slen1;
		long varid[3];

		IGNORE_ALL_RESPONSE_CODES();

		slen1 = 60;

		switch (ivar_value(measurement_type))
		{
			case 1:
				sensor_select = 2;
				break;

			case 2:
				sensor_select = 2;
				break;

			case 4:
				sensor_select = SELECT_FROM_LIST("Measure cable resistance for:","sensor1;sensor2");
				break;

			case 6:
				sensor_select = 2;
				break;

			case 7:
				sensor_select = 2;
				break;

			case 10:
				sensor_select = 2;
				break;

			case 11:
				sensor_select = 2;
				break;

			case 13:
				sensor_select = 0;
				break;

			case 14:
				sensor_select = 0;
				break;

			case 15:
				sensor_select = 0;
				break;

			case 16:
				sensor_select = SELECT_FROM_LIST("Measure cable resistance for:","sensor1;sensor2");
				break;

			default:
			process_abort();
		}

		assign_int(cable_resistance_config,0);
		send(142,status);
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(142,status[STATUS_RESPONSE_CODE]);
			process_abort();
		}

		get_dictionary_string(remove_loop_from_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);

		add_abort_method(return_to_normal);

		stored_upper_range_value=fvar_value(upper_range_value);
		stored_lower_range_value=fvar_value(lower_range_value);
		stored_pv_digital_units=ivar_value(pv_digital_units);
		stored_damping_value=fvar_value(damping_value);
		stored_cable_resistance1=fvar_value(cable_resistance_value);
		stored_sensor_type=ivar_value(sensor_type);
		stored_measurement_type=ivar_value(measurement_type);
		stored_sensor_error_code=ivar_value(sensor_error_code);
		stored_const_cjc_value=fvar_value(const_cjc_value);

		switch (sensor_select)
		{
			case 0:
				ACKNOWLEDGE("Connect sensor1 to terminals 3 and 6, and short circuit the wires as close as possible to the sensor");
				break;

			case 1:
				ACKNOWLEDGE("Connect sensor2 to terminals 3 and 6, and short circuit the wires as close as possible to the sensor");
				break;

			case 2:
				ACKNOWLEDGE("Connect external CJC sensor to terminals 3 and 6, and short circuit the wires as close as possible to the sensor");
				break;

			default:
				ACKNOWLEDGE("error in method!");
				process_abort();

		}

		remove_abort_method(return_to_normal);
		add_abort_method(restore_configuration);
		add_abort_method(return_to_normal);

		assign_float(upper_range_value,100);
		assign_float(lower_range_value,0);
		assign_int(pv_digital_units,37);		/*Ohms*/
		assign_float(damping_value,4e-1);
		assign_int(sensor_type,0);
		assign_int(measurement_type,13);
		assign_int(sensor_error_code,0);
		assign_int(cable_resistance_config,0);
		assign_float(cable_resistance_value,0);
		assign_float(const_cjc_value,0);

/*	send damping value: (0,4) 	*/
		send(34,status);
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(34,status[STATUS_RESPONSE_CODE]);
			com_error = 1;
		}

/*	send units (ohms)	:	*/
		if(com_error==0)
		{
			send(44,status);
			if(status[STATUS_RESPONSE_CODE])
			{
				display_response_status(44,status[STATUS_RESPONSE_CODE]);
				com_error = 1;
			}
		}

/*	send sensor config: (2-w ohm)	*/
		if(com_error==0)
		{
			send(141,status);
			if(status[STATUS_RESPONSE_CODE])
			{
				display_response_status(141,status[STATUS_RESPONSE_CODE]);
				com_error = 1;
			}
		}

/*	send pv range:(0-100 ohm)	*/
		if(com_error==0)
		{
			send(35,status);
			if(status[STATUS_RESPONSE_CODE])
			{
				display_response_status(35,status[STATUS_RESPONSE_CODE]);
				com_error = 1;
			}
		}

/*	send sensor error config: (no detect.)	*/
		if(com_error==0)
		{
			send(151,status);
			if(status[STATUS_RESPONSE_CODE])
			{
				display_response_status(151,status[STATUS_RESPONSE_CODE]);
				com_error = 1;
			}
		}

/*	send cableres.: (0 ohm)	*/
		if(com_error==0)
		{
			send(143,status);
			if(status[STATUS_RESPONSE_CODE])
			{
				display_response_status(143,status[STATUS_RESPONSE_CODE]);
				com_error = 1;
			}
		}

		if(com_error==0)
		{
			DELAY(5,"wait... measuring cable resistance");
			send(1,status);
			if(status[STATUS_RESPONSE_CODE])
			{
				display_response_status(1,status[STATUS_RESPONSE_CODE]);
				com_error = 1;
			}
		}

		if(com_error==0)
		{
			if(fvar_value(pv_digital_value)<=100)
			{
				if(fvar_value(pv_digital_value)<=40)
				{
					assign_float(upper_range_value,40);
				}
				else
				{
					assign_float(upper_range_value,fvar_value(pv_digital_value));
				}
				send(35,status);
				if(status[STATUS_RESPONSE_CODE])
				{
					display_response_status(35,status[STATUS_RESPONSE_CODE]);
					com_error = 1;
				}
				if(com_error==0)
				{
					DELAY(5,"wait... measuring cable resistance");

					do
					{
						send(1,status);
						if(status[STATUS_RESPONSE_CODE])
						{
							display_response_status(1,status[STATUS_RESPONSE_CODE]);
							com_error = 1;
						}
						choice=1;
						if(com_error==0)
						{
							varid[0] =VARID(pv_digital_value);
							varid[1] =VARID(pv_digital_units);
							switch (sensor_select)
							{
								case 0:
									choice = select_from_list("Sensor1 cable resistance: %{0} %{1}",varid,"OK;Original value;Read new value");
									break;
								case 1:
									choice = select_from_list("Sensor2 cable resistance: %{0} %{1}",varid,"OK;Original value;Read new value");
									break;
								case 2:
									choice = select_from_list("External CJC sensor cable resistance: %{0} %{1}",varid,"OK;Original value;Read new value");
									break;
								default:
									ACKNOWLEDGE("error in method");
									process_abort();
							}
						}
					} while(choice==2);


					if(choice ==0)
					{
						assign_float(cable_resistance_value,fvar_value(pv_digital_value));
						assign_int(cable_resistance_config,sensor_select);
						send(143,status);
						if(status[STATUS_RESPONSE_CODE])
						{
							display_response_status(143,status[STATUS_RESPONSE_CODE]);
							com_error = 1;
						}
					}
					else
					{
						sensor_select=1;
					}
				}
			}
			else
			{
				ACKNOWLEDGE("Cable resistance too high, set to original value!");
				sensor_select=1;
			}
		}

		if(com_error)
		{
			sensor_select=1;
		}

		assign_float(upper_range_value,stored_upper_range_value);
		assign_float(lower_range_value,stored_lower_range_value);
		assign_int(pv_digital_units,stored_pv_digital_units);
		assign_float(damping_value,stored_damping_value);
		assign_int(sensor_type,stored_sensor_type);
		assign_int(measurement_type,stored_measurement_type);
		assign_int(sensor_error_code,stored_sensor_error_code);
		assign_float(const_cjc_value,stored_const_cjc_value);

		com_error = 0;

		remove_abort_method(restore_configuration);

		send(34,status);			/* restoring damping value */
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(34,status[STATUS_RESPONSE_CODE]);
			com_error = 1;
		}

		if(com_error==0)
		{
			send(44,status);
			if(status[STATUS_RESPONSE_CODE])
			{
				display_response_status(44,status[STATUS_RESPONSE_CODE]);
				com_error = 1;
			}
		}

		if (sensor_select)		/* restoring cable res. for sensor 1 */
		{
			assign_int(cable_resistance_config,0);
			assign_float(cable_resistance_value,stored_cable_resistance1);
			if(com_error==0)
			{
				send(143,status);
				if(status[STATUS_RESPONSE_CODE])
				{
					display_response_status(143,status[STATUS_RESPONSE_CODE]);
					com_error = 1;
				}
			}
		}

		if(com_error==0)
		{
			send(141,status);
			if(status[STATUS_RESPONSE_CODE])
			{
				display_response_status(141,status[STATUS_RESPONSE_CODE]);
				com_error = 1;
			}
		}

		if(com_error==0)
		{
			send(35,status);
			if(status[STATUS_RESPONSE_CODE])
			{
				display_response_status(35,status[STATUS_RESPONSE_CODE]);
				com_error = 1;
			}
		}

		if(com_error==0)
		{
			send(151,status);
			if(status[STATUS_RESPONSE_CODE])
			{
				display_response_status(151,status[STATUS_RESPONSE_CODE]);
				com_error = 1;
			}
		}


		if(com_error>0)
		{
			ACKNOWLEDGE("Due to communication error(s), measurement could not be performed, be aware that the configuration of the device could be currupt!!");
		}

		process_abort();
	}
}


METHOD restore_configuration
{
	LABEL "restoring configuration";
	DEFINITION
	{

			ACKNOWLEDGE("Due to abortion, measurement could not be performed, be aware that the configuration of the device could be currupt!!");
	}
}


METHOD broken_namur_down
{
	LABEL "Set NAMUR Down For Broken Sensor";
	HELP "Enables broken sensor error detection, and sets the error output value to 3.5 mA acc. to NAMUR NE43";
	DEFINITION
	{
		char status[STATUS_SIZE];

		IGNORE_ALL_RESPONSE_CODES();
		ACKNOWLEDGE("Sets broken sensor output value to 3.5 mA, and enables broken sensor detection");
		assign_float(broken_sensor_value,35e-1);
		assign_int(sensor_error_code,(ivar_value(sensor_error_code) | 0x1));
		send(151,status);
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(151,status[STATUS_RESPONSE_CODE]);
		}
	}
}


METHOD broken_namur_up
{
	LABEL "Set NAMUR Up For Broken Sensor";
	HELP "Enables broken sensor error detection, and sets the error output value to 23 mA acc. to NAMUR NE43";
	DEFINITION
	{
		char status[STATUS_SIZE];

		IGNORE_ALL_RESPONSE_CODES();
		ACKNOWLEDGE("Sets broken sensor output value to 23 mA, and enables broken sensor detection");
		assign_float(broken_sensor_value,23);
		assign_int(sensor_error_code,(ivar_value(sensor_error_code) | 0x1));
		send(151,status);
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(151,status[STATUS_RESPONSE_CODE]);
		}
	}
}

METHOD shorted_namur_down
{
	LABEL "Set NAMUR Down For Shorted Sensor";
	HELP "Enables shorted sensor error detection, and sets the error output value to 3.5 mA acc. to NAMUR NE43";
	DEFINITION
	{
		char status[STATUS_SIZE];

		IGNORE_ALL_RESPONSE_CODES();
		ACKNOWLEDGE("Sets shorted sensor output value to 3.5 mA, and enables shorted sensor detection");
		assign_float(shorted_sensor_value,35e-1);
		assign_int(sensor_error_code,(ivar_value(sensor_error_code) | 0x2));
		send(151,status);
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(151,status[STATUS_RESPONSE_CODE]);
		}
	}
}


METHOD shorted_namur_up
{
	LABEL "Set NAMUR Up For Shorted Sensor";
	HELP "Enables shorted sensor error detection, and sets the error output value to 23 mA acc. to NAMUR NE43";
	DEFINITION
	{
		char status[STATUS_SIZE];

		IGNORE_ALL_RESPONSE_CODES();
		ACKNOWLEDGE("Sets shorted sensor output value to 23 mA, and enables shorted sensor detection");
		assign_float(shorted_sensor_value,23);
		assign_int(sensor_error_code,(ivar_value(sensor_error_code) | 0x2));
		send(151,status);
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(151,status[STATUS_RESPONSE_CODE]);
		}

	}
}


METHOD set_output_limits_namur
{
	LABEL "Set Output Limits To NAMUR";
	HELP "Sets the analog output limits to 3.8 mA and 20.5 mA acc. to NAMUR NE43";
	DEFINITION
	{
		char status[STATUS_SIZE];

		IGNORE_ALL_RESPONSE_CODES();
		ACKNOWLEDGE("Setting lower analog output limit to 3.8 mA and upper analog output limit to 20.5 mA");
		assign_float(current_output_lower_limit,38e-1);
		assign_float(current_output_upper_limit,205e-1);
		send(147,status);
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(147,status[STATUS_RESPONSE_CODE]);
		}

	}
}


METHOD override_dac_trim
{
	LABEL "Override D/A trim";
	HELP	"Overrides any previously D/A trimming by restoring factory calibration values";
	DEFINITION
	{
		char status[STATUS_SIZE];

		IGNORE_ALL_RESPONSE_CODES();
		ACKNOWLEDGE("Override D/A trimming with factory calibration");
		send(154,status);
		if(status[STATUS_RESPONSE_CODE])
		{
			display_response_status(154,status[STATUS_RESPONSE_CODE]);
		}

	}
}


/*
 * Relations
 */
REFRESH sensor_type_refresh
{
	pv_digital_units,
	sensor_type,
	measurement_type,
	meter_option,
	system_config,
	const_cjc_value,
	rtd_factor,
	abs_max_value:
	atemperature_upper_sensor_limit,
	atemperature_lower_sensor_limit,
	atemperature_minimum_span,
	upper_range_value,
	lower_range_value
}


UNIT pv_units_relations
{
	PV.DIGITAL_UNITS:
	PV.DIGITAL_VALUE,
	PV.UPPER_RANGE_VALUE,
	PV.LOWER_RANGE_VALUE,
	const_cjc_value,
	abs_max_value,
	PV.UPPER_SENSOR_LIMIT,
	PV.LOWER_SENSOR_LIMIT,
	PV.MINIMUM_SPAN
}


UNIT CJC_electr_temp_units_relations
{
	cjc_electr_sensor_units:
	cjc_electr_sensor_digital_value
}


UNIT sensor1_temp_units_relations
{
	sensor1_units:
	sensor1_digital_value
}


UNIT sensor2_temp_units_relations
{
	sensor2_units:
	sensor2_digital_value
}


EDIT_DISPLAY sensor_hookup
{
	LABEL [sensor_configuration];
	EDIT_ITEMS
	{
		sensor_type,
		measurement_type,
		const_cjc_value,
		rtd_factor,
		abs_max_value
	}
}

METHOD method_sensor_type
{
	LABEL	"update sensor type";
	CLASS	INPUT;
	DEFINITION
	{
    int unit, type;

    unit = ivar_value(pv_digital_units);
    type = ivar_value(sensor_type);
    // If temperature
		if(unit == degC || unit == degF || unit == degR || unit == degK)
    {
      // Check for correct sensor
      switch(type) {
		    case 1:   break; /* "Pt100 IEC 751" */
		    case 2:   break; /* "Ni100 DIN 43760" */
		    case 5:   break; /* "RTD Special" */
		    case 129: break; /* "T/C Type B IEC 584" */
		    case 130: break; /* "T/C Type E IEC 584" */
		    case 131: break; /* "T/C Type J IEC 584" */
		    case 132: break; /* "T/C Type K IEC 584" */
		    case 133: break; /* "T/C Type L DIN 43710" */ 
		    case 134: break; /* "T/C Type N IEC 584" */
		    case 135: break; /* "T/C Type R IEC 584" */
		    case 136: break; /* "T/C Type S IEC 584" */
		    case 137: break; /* "T/C Type T IEC 584" */
		    case 138: break; /* "T/C Type U DIN 43710" */
		    case 139: break; /* "T/C Type W3 ASTM" */
		    case 140: break; /* "T/C Type W5 ASTM" */
		    case 141: break; /* "T/C Special" */
        default : iassign(sensor_type, 1); break;
      }
    }
    // If V or mV
    else if(unit == Volt || unit == mVolt)
    { iassign(sensor_type, 128); } // Default to mV
    // If Ohm or kOhm
    else if(unit == _Ohm || unit == kOhm)
    { iassign(sensor_type, 0); } // Default to Ohm
    // Else type must be mV or Ohm
    else if(type != 0 && type != 128)
    { iassign(sensor_type, 0); } // Default to Ohm
  }
}

METHOD method_measurement_type
{
	LABEL	"update measurement type";
	CLASS	INPUT;
	DEFINITION
	{
    int type;

    type   = ivar_value(measurement_type);
    switch(ivar_value(sensor_type)) {
      case 0:
        if(type != 4 && (type < 12 || type > 16))
        { iassign(measurement_type, 14); }
        break;
      case 1:
        if(type != 4 && (type < 13 || type > 16))
        { iassign(measurement_type, 14); }
        break;
      case 2:
        if(type != 4 && (type < 13 || type > 16))
        { iassign(measurement_type, 14); }
        break;
      case 5:
        if(type != 4 && (type < 13 || type > 16))
        { iassign(measurement_type, 14); }
        break;
      case 128:
        if(type != 3 && type != 8 && type != 12)
        { iassign(measurement_type, 8); }
        break;
      default:
        if(type == 4 || type > 12)
        { iassign(measurement_type, 5); }
        break;
    }
  }
}

METHOD method_rtd_factor
{
	LABEL	"update rtd_factor";
	CLASS	INPUT;
	DEFINITION
	{
    float fval;
    
    fval = fvar_value(rtd_factor);
    if(fval < 0.1)
    { fassign(rtd_factor, 0.1); }
    else if(fval > 10.0)
    { fassign(rtd_factor, 10.0); }
  }
}

METHOD method_sensor_limits
{
	LABEL	"update sensor limits";
	CLASS	INPUT;
	DEFINITION
	{
		float	lower_val, upper_val, span_val;
    float input_min, input_max;
    float value_max;
		switch (ivar_value(sensor_type))
		{
			case 0:   lower_val =	   0.0;	upper_val = 7000.0; span_val =  25.0; break;  /* Ohm            */
			case 1:	  lower_val = -200.0;	upper_val =  850.0;	span_val =  10.0; break;	/* Pt10		IEC	    */
			case 2:	  lower_val =  -60.0;	upper_val =  250.0;	span_val =  10.0; break;	/* Ni100	   	    */
			case 5:	  lower_val = -200.0;	upper_val =  850.0;	span_val =  10.0; break;	/* Custom RTD	    */ 
			case 128: lower_val =	-800.0;	upper_val =  800.0; span_val =  10.0; break;  /* mV             */
			case 129:	lower_val =  400.0;	upper_val = 1820.0;	span_val = 100.0; break;	/* TC type B      */
			case 130:	lower_val = -100.0;	upper_val = 1000.0;	span_val =  50.0; break;	/* TC type E	    */
			case 131:	lower_val = -100.0;	upper_val = 1200.0;	span_val =  50.0; break;	/* TC type J	    */
			case 132:	lower_val = -180.0;	upper_val = 1372.0;	span_val =  50.0; break;	/* TC type K	    */
			case 133:	lower_val = -100.0;	upper_val =  900.0;	span_val =  50.0; break;	/* TC type L	    */
			case 134:	lower_val = -180.0;	upper_val = 1300.0;	span_val =  50.0; break;	/* TC type N	    */
			case 135:	lower_val =  -50.0;	upper_val = 1760.0;	span_val = 100.0; break;	/* TC type R	    */
			case 136:	lower_val =  -50.0;	upper_val = 1760.0;	span_val = 100.0; break;	/* TC type S	    */ 
			case 137:	lower_val = -200.0;	upper_val =  400.0;	span_val =  50.0; break;	/* TC type T	    */ 
			case 138:	lower_val = -200.0;	upper_val =  600.0;	span_val =  50.0; break;	/* TC type U	    */ 
			case 139:	lower_val =    0.0;	upper_val = 2300.0;	span_val = 100.0; break;	/* TC type W3	    */ 
			case 140:	lower_val =    0.0;	upper_val = 2300.0;	span_val = 100.0; break;	/* TC type W5	    */ 
      default: return;
		}
		CELSIUS_TO_CURRENT_UNIT(lower_val);
		CELSIUS_TO_CURRENT_UNIT(upper_val);
		CELSIUS_TO_CURRENT_UNIT(span_val);
    // Set sensor limits
		fassign(atemperature_lower_sensor_limit, lower_val);
		fassign(atemperature_upper_sensor_limit, upper_val);
		fassign(atemperature_minimum_span,       span_val);

    // Get input ranges
    input_min = fvar_value(lower_range_value);
    input_max = fvar_value(upper_range_value);
    // Range validation
    if(input_min < lower_val)  { input_min = lower_val; }
    if(input_max > upper_val)  { input_max = upper_val; }
    if(input_max <= lower_val) { input_max = lower_val + 1.0; }
    if(input_min >= input_max) { input_min = input_max - 1.0; }
    // Set input ranges
		fassign(lower_range_value, input_min);
		fassign(upper_range_value, input_max);

    // Get max input value
    value_max = fvar_value(abs_max_value);
    if(value_max < lower_val)
    { fassign(abs_max_value, lower_val); }
    else if(value_max > upper_val)
    { fassign(abs_max_value, upper_val); }
	}
}

METHOD method_output_values
{
        LABEL   "update output values";
        CLASS   INPUT;
        DEFINITION
        {
    float fval;

    fval = fvar_value(current_output_0);
    if(fval < 3.8)
    { fassign(current_output_0, 3.8); }
    else if(fval > 22.0)
    { fassign(current_output_0, 22.0); }

    fval = fvar_value(current_output_100);
    if(fval < 3.8)
    { fassign(current_output_100, 3.8); }
    else if(fval > 22.0)
    { fassign(current_output_100, 22.0); }
  }
}

METHOD method_output_limits
{
        LABEL   "update output values";
        CLASS   INPUT;
        DEFINITION
        {
    float o0,  o100;
    float lim, val;

    // Range (may have reversed output)
    o0   = fvar_value(current_output_0);
    o100 = fvar_value(current_output_100);
    // Check lower mimits
    lim = min(o0, o100);
    val = fvar_value(current_output_lower_limit);
    if(val < 3.5)
    { fassign(current_output_lower_limit, 3.5); }
    else if(val > lim)
    { fassign(current_output_lower_limit, lim); }
    // Check upper mimits
    lim = max(o0, o100);
    val = fvar_value(current_output_upper_limit);
    if(val < lim)
    { fassign(current_output_upper_limit, lim); }
    else if(val > 23.0)
    { fassign(current_output_upper_limit, 23.0); }
  }
}


METHOD method_broken_shorted
{
	LABEL	"update broken shorted values";
	CLASS	INPUT;
	DEFINITION
	{
    float val;
    
    val = fvar_value(shorted_sensor_value);
    if(val < 3.5)
    { fassign(shorted_sensor_value, 3.5); }
    else if(val > 23.0)
    { fassign(shorted_sensor_value, 23.0); }

    val = fvar_value(broken_sensor_value);
    if(val < 3.5)
    { fassign(broken_sensor_value, 3.5); }
    else if(val > 23.0)
    { fassign(broken_sensor_value, 23.0); }
  }
}

METHOD method_damping_value
{
	LABEL	"update damping values";
	CLASS	INPUT;
	DEFINITION
	{
    float val;
    
    val = fvar_value(damping_value);
    if(val < 1.0)
    { fassign(damping_value, 1.0); }
    else if(val > 60.0)
    { fassign(damping_value, 60.0); }
  }
}

METHOD method_const_cjc_value
{
	LABEL	"update const cjc value";
	CLASS	INPUT;
	DEFINITION
	{
    float value_min, value_max;
    float value_cjc;

    value_min = -20.0;
    value_max = 85.0;
		CELSIUS_TO_CURRENT_UNIT(value_min);
		CELSIUS_TO_CURRENT_UNIT(value_max);

    value_cjc = fvar_value(const_cjc_value);
    if(value_cjc < value_min)
    { fassign(value_cjc, value_min); }
    else if(value_cjc > value_max)
    { fassign(value_cjc, value_max); }
  }
}

